<?php
/**
 * Init
 *
 * @package Cardealer Vin Import
 */

if ( ! function_exists( 'cdvi_script_style_admin' ) ) {
	/**
	 * Enqueue script
	 */
	function cdvi_script_style_admin() {
		global $post_type;

		$current_screen = get_current_screen();

		wp_register_script( 'cdhl-jquery-vin-import', trailingslashit( CDVI_URL ) . 'js/cardealer_vin_import.js', array(), false, true );

		if ( 'cars' === $post_type || ( 'cars_page_cars-vin-import' === $current_screen->id ) ) {
			wp_enqueue_script( 'cdhl-jquery-vin-import' );
		}
	}
}
add_action( 'admin_enqueue_scripts', 'cdvi_script_style_admin' );

// Add Theme Options
function car_dealer_options__edmunds_vin_settings( $opt_name ) {
	Redux::setSection(
		$opt_name,
		array(
			'title'            => esc_html__( 'Edmunds VIN Settings', 'cardealer-helper' ),
			'id'               => 'edmunds_vin_settings',
			'icon'             => 'fas fa-chevron-right',
			'subsection'       => true,
			'fields'           => array(
				array(
					'id'     => 'edmunds-section-start',
					'type'   => 'section',
					'title'  => esc_html__( 'Edmunds API', 'cardealer-helper' ),
					'indent' => true,
				),
				array(
					'id'      => 'edmunds_api_key',
					'type'    => 'text',
					'title'   => esc_html__( 'API Key', 'cardealer-helper' ),
					'desc'    => '',
					'default' => '',
				),
				array(
					'id'      => 'edmunds_api_secret',
					'type'    => 'text',
					'title'   => esc_html__( 'API Secret', 'cardealer-helper' ),
					'desc'    => sprintf(
						wp_kses(
							/* translators: %s: url */
							__( 'You can get Edmunds API details from <a href="%1$s" target="_blank">here</a>', 'cardealer-helper' ),
							array(
								'a' => array(
									'href'   => array(),
									'target' => array(),
								),
							)
						),
						esc_url( 'http://developer.edmunds.com/' )
					),
					'default' => '',
				),
				array(
					'id'     => 'edmunds-section-end',
					'type'   => 'section',
					'indent' => false,
				),
			),
		)
	);
}
add_action( 'car_dealer_options_after_vehicle_settings', 'car_dealer_options__edmunds_vin_settings' );
